class MyHookClass : MLHook::HookMLEventsByType{

  private MLHook::PendingEvent@[] pendingEvents = {};
  
  MyHookClass(const string &in type = "MLHook_menu_action") {
    super("MLHook_menu_action");
    startnew(CoroutineFunc(this.MainCoro));
  }

  void OnEvent(MLHook::PendingEvent@ event) override {
    pendingEvents.InsertLast(event);
  }

  void MainCoro() {
      while (true) {     
          yield();
          while (pendingEvents.Length > 0) {
              auto event = pendingEvents[pendingEvents.Length - 1];
              pendingEvents.RemoveLast();
              ProcessEvent(event);
          }
      }
  }

  void ProcessEvent(MLHook::PendingEvent@ event) {
    if (event.data.Length == 0) return;
    try {
      auto menus = cast<CTrackManiaMenus>(GetTmApp().MenuManager);
      auto overlay = cast<CGameSystemOverlay>(GetTmApp().SystemOverlay);
      auto command = event.data[0];
      if(command == "replays" && canUseEditors)
        GoToReplays();
      if(command == "editors" && canUseEditors)
        menus.MenuEditors(); 
      if(command == "local" && canUseLocalPlay)
        GoToLocalPlay();    
      if(command == "local_server")
        menus.MenuMultiPlayer_OnInternet();   
      if(command == "main_menu")
        GoToMainMenu();      
      if(command == "update_tp"){
        LeaveTitlepack();
        UpdateTitlepack();
      }     
      if(command == "download_all_maps"){
        LeaveTitlepack();
        DownloadAllMaps();
      }
      if(command == "input_settings")
        overlay.OpenInputSettings();
      if(command == "graphic_settings")
        overlay.OpenGraphicSettings();
      if(command == "streoscopy_settings")
        overlay.OpenStereoscopySettings();
      if(command == "horns")
        menus.MenuProfile_OnChangeHorn();
      if(command == "enter_titlepack")
        EnterTitlepack();
      if(command == "quit_titlepack")
        LeaveTitlepack();
      if(command == "show_demo_dialog")
        ShowDemoDialog();
      if(command == "hide_demo_dialog")
        HideAllDialogs();
      if(command == "update_dialog_update")
        UpdateTitlepack();
      if(command == "update_dialog_ignore")
        HideAllDialogs();
      if(command == "hide_demo_exit")
        LeaveTitlepack();
    }
    catch {

    }
  }
}